#ifndef _monitor_h
#define _monitor_h

// Monitor server program. Caches compute servers

#include "mon_s.hh"		// Monitor server
#include "comp_c.hh"		// ComputeServer client


class MonitorServer: public Monitor_impl, public CORBA::BOA::IMPLEventHandler
{
    private:
	ServerList		_servers;
	AccessControlList	_userList;
	CORBA::ULong		_cur_index;
    protected:
	void	unbind(const CORBA::Principal& princ, const char *interface,
				const CORBA::Object& obj);
    public:
	MonitorServer(const char *name) : Monitor_impl(name) { _cur_index = 0;}
	~MonitorServer() {}

	void		add_user(const char *name);
	CORBA::Boolean  valid_user(const CORBA::Principal *princ);

	void 		register_server(ComputeServer *server);

	ComputeServer 	*get_server(CORBA::Environment& env);
};


#endif
	
