#ifndef _corbadii_h_
#define _corbadii_h_
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1992, 1993 by PostModern Computing Technologies, Inc.         */
/*                          1032 Elwell Court, Suite 240                    */
/*                          Palo Alto, California, USA                      */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/*  Author: psm                                                             */
/*                                                                          */
/****************************************************************************/

#include <corba.h>
#include <irclnt.hh>

class CORBA_DII
{
public:

class Request: public CORBA::Object
{
    protected:
	CORBA_IR::OperationDescription 	*_desc;

	Request(CORBA_IR::OperationDescription *desc);
	Request(const Request& ) {}
	void operator=(const Request& ) {}
	virtual ~Request();


	virtual void _receive_reply(CORBA::MarshalStream& strm,
				CORBA::Environment& env) =0;
	virtual void _exception(CORBA::Environment& env) =0;
    public:
	static Request *create(const char *interface_name,
			const char *operation_name,
			const char *repository_server_name,
			CORBA::Environment& env);

	static Request *create(
			CORBA_IR::InterfaceDef::FullInterfaceDescription *desc, 
			const char *operation_name,
			CORBA::Environment& env);

	static Request *create(CORBA_IR::InterfaceDef *interfaceDef, 
			const char *operation_name,
			CORBA::Environment& env);

	static Request *create(CORBA::Object *obj, 
			const char *operation_name,
			const char *repository_server_name,
			CORBA::Environment& env);
			
	virtual void	bind(const char *object_name = (const char *)NULL, 
				const char *host_name = (const char *)NULL,
				const CORBA::BindOptions *bopt = 
					(const CORBA::BindOptions *)NULL) =0;
	
	virtual void	unbind() =0;

	CORBA::Long	index(const char *arg_name) const;

	const 	CORBA::TypeCode& arg_type(CORBA::Long index) const;
	const 	CORBA::TypeCode& arg_type(const char *arg_name) const {
			return arg_type(index(arg_name));
	}

	CORBA::Long param_count() const;
	
	CORBA_IR::ParameterDef::ParameterMode arg_mode(CORBA::Long index) 
					const;
	CORBA_IR::ParameterDef::ParameterMode arg_mode(const char *arg_name) 
					const {
			return arg_mode(index(arg_name));
	}

	const 	CORBA::TypeCode& result_type();

	virtual void 	arg(CORBA::Long index, CORBA::Value *value) =0;
	virtual void 	arg(CORBA::Long index, const CORBA::Value& value)=0;

	void 	arg(const char *arg_name, CORBA::Value *value) {
			arg(index(arg_name), value);
	}
	void 	arg(const char *arg_name, const CORBA::Value& value) {
			arg(index(arg_name), value);
	}


	virtual const 	CORBA::Value *arg(CORBA::Long index ) const =0;
	virtual CORBA::Value *arg(CORBA::Long index) =0;

	const 	CORBA::Value *arg(const char *arg_name) const {
			return arg(index(arg_name));
	}
	CORBA::Value *arg(const char *arg_name) {
			return arg(index(arg_name));
	}
	

	virtual const CORBA::Value *result() const =0;
	virtual CORBA::Value *result() =0;

	virtual void	context(const CORBA::Context& ctx) =0;
	virtual const 	CORBA::Context *context() const=0;

	virtual void 	send() =0;
	virtual void 	send_oneway()=0;
	virtual void   	invoke() =0;

	virtual CORBA::Boolean poll_response() =0;
	virtual void    pend_response()=0;

	static Request *poll_next_response();
	static Request *pend_next_response();
	static void	send(Request* req_array[], CORBA::ULong count);
	static void	invoke(Request* req_array[], CORBA::ULong count);
};
	
};

#endif
