// "@(#)Module Name: dsordcltn.h Version:2.1 Date: 94/06/19"
#ifndef _dsordcltn_h
#define _dsordcltn_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/
#include <dscltn.h>

// --------------------------------------------------------------------------
// Implementation of OrderedCollection. OrderedCollection is a container
// for Objects.
// --------------------------------------------------------------------------
class DSOrderedCltn: public DSCollection
{
	DECLARE_TRANS_CLASS(DSOrderedCltn);
    protected:
	unsigned	_capacity;
	unsigned	_count;
	DSResource	**_objArray;

	DSResource *addAtIndex(unsigned i, DSResource& obj);
	NCbool removeAtIndex(int i);
    public:
	virtual int	compare(const NCObject& p) const;
	virtual unsigned hash() const;
	
	DSOrderedCltn(unsigned size = 16);
	virtual ~DSOrderedCltn();

	void	operator=(const DSOrderedCltn& );
	virtual DSResource *addFirst(DSResource& obj) { return addAtIndex(0, obj); }
	virtual DSResource *add(DSResource& obj) { return addAtIndex(_count, obj); }
	virtual DSResource *addAfter(const DSResource& old, DSResource& newObj);
	virtual DSResource *addBefore(const DSResource& old, DSResource& newObj);
	virtual DSResource *at(int i) const;
	virtual DSResource *first() const { return at(0); }
	virtual DSResource *last() const { return at(_count -1); }
// remove function removes using isEqual, whereas removeSame removes using
// isSame.
	virtual NCbool remove(const DSResource& obj);
	virtual NCbool removeSame(const DSResource& obj);
	virtual NCbool removeAt(int i);
	virtual NCbool removeFirst() { return removeAt(0); }
	virtual NCbool removeLast() { return removeAt(_count -1); }
	virtual unsigned occurrencesOf(const DSResource& ) const; 
	virtual void	 removeAll();
	virtual unsigned size() const { return _count; }
	virtual unsigned capacity() const { return _capacity; }
	virtual DSResource *doNext(DSIterator& ) const;
	virtual int indexOf(const DSResource& obj) const;
};
#endif
