#ifndef _except_h
#define _except_h
/****************************************************************************/
/*                                                                          */
/*  ORBeline (c)   is copyrighted by PostModern Computing Technologies, Inc */
/*                                                                          */
/*  Copyright 1993, 1994 by PostModern Computing Technologies, Inc.         */
/*                          1897 Landings Drive                             */
/*                          Mountain View, California, USA                  */
/*                          Telephone (415) 967-6169                        */
/*                          Facsimile (415) 967-6212                        */
/*                                                                          */
/*  This code is the sole property of PostModern Computing Technologies,    */
/*  Inc.  and is  protected  by  copyright under the laws of the United     */
/*  States.   This  program is confidential, proprietary, and  a  trade     */
/*  secret,  not  to  be disclosed  without written authorization  from     */
/*  PostModern Computing Technologies, Inc.  Any use,  duplication,  or     */
/*  disclosure  of  this  program  by other than  PostModern  Computing     */
/*  Technologies, Inc. and its assigned licensees is strictly forbidden     */
/*  by law.                                                                 */
/*                                                                          */
/*  All rights reserved.                                                    */
/*                                                                          */
/****************************************************************************/

// #include <dsresource.h>

class Exception: public DSResource
{
	DECLARE_NCOBJECT_CLASS(Exception);
    protected:
	Exception() {}
    public:
	virtual ~Exception() {}
	virtual const char *_id() const;
	
};

class SystemException: public Exception
{
	DECLARE_NCOBJECT_CLASS(SystemException);
    public:
	enum completion_status {
		YES =0,
		NO=1,
		MAYBE=2
	};

    private:								
	ULong			_minor;					
	completion_status 	_status;				
    protected:
	SystemException() { _minor = 0; _status = NO; }
    public:								

	SystemException(ULong minor, completion_status status) {	
		_minor = minor;						
		_status = status;					
	}								
	virtual ~SystemException() {}

	ULong minorFlag() const { return _minor;}			
	ULong& minorFlag() { return _minor; }				
	void minorFlag(ULong val) { _minor = val; }			
									
	completion_status completed() const { return _status; }		
	completion_status& completed() { return _status; }		
	void completed(completion_status status) { _status = status; }	

	static SystemException *_cast(Exception *exc) {
                if ( !exc) return (SystemException *)NULL;
                else if ( ! exc->canCast(class_info) ) 
			return (SystemException *)NULL;
                else return (SystemException *)exc;
	}
	static const SystemException *_cast(const Exception *exc) {
                if ( !exc) return (SystemException *)NULL;
                else if ( ! exc->canCast(class_info) ) 
			return (SystemException *)NULL;
                else return (SystemException *)exc;
	}
};

#include "stexcep.h"


class UserException: public Exception
{
	DECLARE_NCOBJECT_CLASS(UserException);
    protected:
	UserException() {}
    public:
	virtual ~UserException() {}

	static UserException *_cast(Exception *exc) {
                if ( !exc) return (UserException *)NULL;
                else if ( ! exc->canCast(class_info) ) 
			return (UserException *)NULL;
                else return (UserException *)exc;
	}
	static const UserException *_cast(const Exception *exc) {
                if ( !exc) return (UserException *)NULL;
                else if ( ! exc->canCast(class_info) ) 
			return (UserException *)NULL;
                else return (UserException *)exc;
	}
};


#endif
